/*  asinvert.c
 *
 * The Greenleaf Comm Library
 *
 * Copyright (C) 1985-1990 Greenleaf Software Inc.  All Rights Reserved.
 *
 *  int asinvert(mask)
 *  unsigned mask;      -- Bits of shared port's I/O register to invert.
 *
 *  This function customizes the interrupt routines for use with a particular
 *  Category B board by arranging that the status port data will be inverted.
 *
 *  RETURNS:
 *              ASSUCCESS always.
 *  USAGE:
 *
 * MODIFICATIONS
 */

#include <stdio.h>
#include "gf.h"
#include "asiports.h"

int GF_CONV asinvert(mask)
unsigned mask;
{
        int i;

        _asxorv=mask;
        if(as_chnl)
                for (i=0; i<MAX_PORT; i++)
                        as_chnl->tblport[i].as_xorv = mask;
        return (ASSUCCESS);
}
